<h3>
    Interactions
</h3>

<div class="interactions-filter">
    <input type="text" class="form-control"
      placeholder="Recherche de POIs..."
      maxlength="100"
      ng-model="$ctrl.poiFilterKeywords"
      ng-model-options="{ updateOn: 'default blur', debounce: {default: 300, blur: 0} }" />
</div>

<div ng-show="$ctrl.interactions.getNumInteractions() === 0">
    Pas encore d'interaction définie !
</div>

<div class="list-interaction-container">
    <form>
        <uib-accordion close-others="true" ng-show="$ctrl.interactions.getNumInteractions() > 0">
            <uib-accordion-group
                is-open="$ctrl.interactionOpen[poi.id]"
                ng-show="$ctrl.shouldFilterIncludePoi(poi)"
                ng-repeat="poi in $ctrl.interactions.getInteractions()"
                ng-mouseenter="$ctrl.highlightFeatureFromPoi(poi)"
                ng-mouseleave="$ctrl.unlightFeatureFromPoi(poi)"
                ng-click="$ctrl.visuallySelectFeatureFromPoi(poi)">
                <uib-accordion-heading>
                    <span class="label" ng-class="{'active': poi.id === 'poi-' + $ctrl.currentPoi}"></span>
                    {{poi.label}} <span ng-if="poi.label != poi.id">({{poi.id}})</span>
                </uib-accordion-heading>
                <uib-accordion close-others="false">
                    <div class="poi-properties">
                        <label class="control-label" ng-attr-for="{{ poi.id + '-label' }}">Label</label>
                        <input type="text" class="form-control input-sm"
                            ng-attr-id="{{ poi.id + '-label' }}"
                            placeholder="Label du POI"
                            ng-model="poi.label"
                            style="width:100%"
                            ng-model-options="{ updateOn: 'default blur', debounce: {default: 1000, blur: 0} }"
                            ng-change="$ctrl.onInteractionPropertiesChange();">
                    </div>

                    <uib-accordion-group
                        ng-repeat="filter in $ctrl.interactions.getFilters()"
                        class="list-interactions">

                        <uib-accordion-heading>
                            Filtre : {{filter.name}} <small>({{$ctrl.getInteractionsByFilterLength(poi.interactions, filter.id)}} interaction(s))</small>
                        </uib-accordion-heading>
                        <div class="list-interactions-item" ng-repeat="interaction in poi.interactions | filter:{filter:filter.id}:true">
                            <button type="button"
                                tooltip-placement="left"
                                uib-tooltip="Supprimer l'interaction"
                                class="btn btn-sm btn-default remove-interaction"
                                ng-click="$ctrl.removeInteractionByUUID(interaction.uuid)">

                                <i class="material-icons">delete</i>
                            </button>
                            <div class="col-sm-6 form-group" ng-class="{'has-error': poi.invalidFilterIds && (poi.invalidFilterIds.indexOf(interaction.filter) !== -1)}">
                                <label class="control-label" ng-attr-for="{{ poi.id + '-' + interaction.uuid + '-gesture' }}">Déclencheur</label>
                                <select ng-attr-id="{{ poi.id + '-' + interaction.uuid + '-gesture' }}"
                                    ng-model="interaction.gesture"
                                    class="form-control input-sm"
                                    ng-change="$ctrl.onInteractionPropertiesChange();">

                                    <option value="tap">Clic</option>
                                    <option value="double_tap">Double clic</option>
                                    <option value="long_tap">Appui long</option>
                                </select>
                            </div>
                            <div class="col-sm-6 form-group">
                                <label class="control-label" ng-attr-for="{{ poi.id + '-' + interaction.uuid + '-protocol' }}">Nature du son</label>
                                <select ng-attr-id="{{ poi.id + '-' + interaction.uuid + '-protocol' }}"
                                    ng-model="interaction.protocol"
                                    class="form-control input-sm"
                                    ng-change="$ctrl.onInteractionProtocolChange(interaction);">

                                    <option value="tts">Synthèse vocale</option>
                                    <option value="mp3">MP3</option>
                                </select>
                            </div>
                            <div ng-if="interaction.protocol==='tts'"
                                class="col-sm-12 form-group">

                                <textarea type="text" class="form-control input-sm interaction-value"
                                    placeholder="Valeur (ce qui sera lu)"
                                    ng-model="interaction.value"
                                    style="width:100%"
                                    ng-model-options="{ updateOn: 'default blur', debounce: {default: 1000, blur: 0} }"
                                    ng-change="$ctrl.onInteractionPropertiesChange();"
                                    rows="6">
                                </textarea>
                            </div>

                            <div ng-if-start="interaction.protocol==='mp3'"
                                class="col-sm-12">

                                <label class="control-label" ng-attr-for="{{ poi.id + '-' + interaction.uuid + '-file' }}">Fichier audio</label>
                            </div>

                            <div class="col-sm-8 form-group">
                                <select ng-attr-id="{{ poi.id + '-' + interaction.uuid + '-file' }}"
                                    ng-model="interaction.value"
                                    ng-change="$ctrl.onInteractionPropertiesChange();"
                                    class="form-control input-sm col-sm-9">

                                    <option
                                        ng-repeat="option in $ctrl.interactionAudioFileList"
                                        value="{{option.id}}">

                                        {{option.label}}
                                    </option>
                                </select>
                            </div>

                            <div class="col-sm-2 form-group browse-audio-file">
                                <file-input class="btn btn-sm btn-default"
                                    aria-label="Fichier audio qui sera joué"
                                    tooltip-placement="left"
                                    uib-tooltip="Choisir un fichier audio..."
                                    on-change="$ctrl.importInteractionAudio($event, interaction)"
                                    accept="audio/mpeg3,audio/x-mpeg-3">

                                    <span class="fa fa-lg fa-folder-open" aria-hidden="true"></span>
                                </file-input>
                            </div>

                            <div ng-if-end class="col-sm-2 form-group playback-controls-audio-file">
                                <button type="button"
                                    tooltip-placement="left"
                                    uib-tooltip="Jouer le son"
                                    class="btn btn-sm btn-default"
                                    ng-disabled="interaction.value == ''"
                                    ng-if="!$ctrl.interactionAudioPreviewPlaying"
                                    ng-click="$ctrl.playInteractionSound(interaction)">

                                    ▶
                                </button>
                                <button type="button"
                                    tooltip-placement="left"
                                    uib-tooltip="Arrêter le son"
                                    class="btn btn-sm btn-default"
                                    ng-if="$ctrl.interactionAudioPreviewPlaying"
                                    ng-click="$ctrl.stopInteractionSound()">

                                    ⏹
                                </button>
                            </div>

                            <button type="button"
                                class="btn btn-sm btn-default pull-right duplicate-interaction"
                                ng-click="$ctrl.duplicateInteractionToAllFilters(poi.id, interaction)">

                                <i class="material-icons mat-btn">library_add</i> Dupliquer sur tous les filtres
                            </button>
                        </div>
                        <div class="list-interactions-footer">
                            <div class="has-error" ng-if="poi.invalidFilterIds && (poi.invalidFilterIds.indexOf(filter.id) !== -1)">
                                <span class="help-block">Attention : il ne peut y avoir qu'une seule interaction pour un même filtre et un même déclencheur sur un même élément.</span>
                            </div>
                            <button type="button"
                                class="btn btn-sm btn-default pull-right"
                                ng-click="$ctrl.addInteraction(poi.id, null, filter.id)">

                                <i class="material-icons mat-btn">add</i> Nouvelle interaction
                            </button>
                        </div>
                    </uib-accordion-group>
                </uib-accordion>
            </uib-accordion-group>
        </uib-accordion>
    </form>
</div>

<h3 class="header-filters"
    ng-click="isFiltersPanelCollapsed = !isFiltersPanelCollapsed">
    <span ng-class="{ 'is-open': ! isFiltersPanelCollapsed }">
        Filtres ({{$ctrl.interactions.getFilters().length}})
    </span>
</h3>

<div class="list-filters" ng-class="{ 'is-open': ! isFiltersPanelCollapsed }" uib-collapse="isFiltersPanelCollapsed">
    <form class="form-inline">
        <div class="form-group" ng-repeat="filter in $ctrl.interactions.getFilters()">
            <input type="text"
                ng-model="filter.name"
                class="form-control"
                ng-model-options="{ updateOn: 'default blur', debounce: {default: 1000, blur: 0} }"
                ng-change="$ctrl.onInteractionPropertiesChange();">

            <button type="button"
                class="btn btn-sm remove-button"
                ng-click="$ctrl.removeInteractionFilter(filter.id)">

                <i class="material-icons">close</i>
            </button>
        </div>
        <button type="button"
            class="btn btn-sm btn-default pull-right"
            ng-click="$ctrl.addInteractionFilter();">

            <i class="material-icons mat-btn">add</i> Nouveau filtre
        </button>
    </form>
</div>
